{
  inputs = {
    nixpkgs.url = "github:NixOS/nixpkgs/nixos-unstable";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs =
    {
      self,
      nixpkgs,
      flake-utils,
      systems,
    }:
    flake-utils.lib.eachSystem (import systems) (
      system:
      let
        pkgs = import nixpkgs {
          inherit system;
        };
      in
      {
        devShells = {
          default = pkgs.mkShell {
            buildInputs = with pkgs; [
              glibc.static
              go
              gofumpt
              golangci-lint
              gopls
              gotools
              go-tools
              sqlite-interactive
            ];
          };

          helix = pkgs.mkShell {
            packages = with pkgs; [
              marksman # markdown
              nodePackages.prettier # formatting for markdown and yaml
              taplo # toml
              bash-language-server
              shellcheck # dependency for bash-ls
              shfmt # dependency for bash-ls
              yaml-language-server
              treefmt # formatter multiplexer
              nil # nix ls
              nixfmt-rfc-style # formatter for nix
            ];
          };
        };
      }
    );
}
